{{ *****************************
'' GPS routines
''  (c) 2007 Perry James Mole
''  pjm@ridge-communications.ca
'' *****************************

' PVH Comment - Excellent small GPS reader routines.
' $GPRMC  Recommended minimum data                 ie: $GPRMC,081836,A,3751.6565,S,14507.3654,E,000.0,360.0,130998,011.3,E*62
' $GPGGA  GPS Fix Data                             ie: $GPGGA,170834,4124.8963,N,08151.6838,W,1,05,1.5,280.2,M,-34.0,M,,,*75
' $PGRMZ  eTrex proprietary barametric altitude ft ie: $PGRMZ,453,f,2*18

$IIRMC,110857,A,5217.977,N,00515.917,E,00.0,284,150112,00,E,A*08
          0   1    2     3     4     5  6    7     8    9 10 11
$IIVWR,079,R,00.0,N,,,,*6F
         0 1  2   3     4
$IIGLL,5217.977,N,00515.917,E,110857,A,A*5C
          0     1     2     3    4   5  6
$IIMWV,079,R,03.6,N,A*18
         0 1  2   3  4
$IIMWV,079,T,04.2,N,A*1D
         0 1  2   3  4  
RMC, hhmmss,A(Valid),Latitude,N(orth),Longitude,E(ast),0.00(Speedknots), 327(CourseDegreesTrue),(Date),00(MagneticVariation),E(ast),A*08(Checksum)
$IIMWV,079(degrees),R(elative),4.2, N(autical Miles), A (Valid)*1D(checksum)

}}
CON

  CR = 13                     ' ASCII <CR>
  LF = 10                     ' ASCII <LF>
  serXmit   = 10              ' Serial Transmit on mouse EH: op pin0 zit de sd
  serRecv   = 7               ' Serial Receive  on mouse EH:1=>7. Signal tacktick! =)
  
VAR  
   long gps_stack[50]                                             'In the past I had problems with only 10 as stack space.
                                                                  'For a start try to use 30 or 50 in GPS_IO_mini
   byte RMCb[80],VWRb[40],MWVb[40]',GPGGLb[80],PGRMZb[40]        'EH: added MWVb[40] 100?
   long RMCa[20],VWRa[20],MWVa[20]',GPGGLa[20],PGRMZa[20]        'EH: added MWVb[20]

                                                  
   byte gps_buff[160],Rx',cksum
   long cog,cptr,ptr,arg,j
   long Null[1]
   
OBJ
  uart :  "FullDuplexSerial_mini"

PUB start : okay

  okay := uart.start(serRecv,serXmit,1,4800)            '' Starts uart object (at baud specified) in a cog 
  return cog := cognew(readNEMA,@gps_stack) + 1         '' -- returns false if no cog available
  
'' start(rxpin, txpin, mode, baudrate) : okay
'' Start serial driver - starts a cog
'' --returns false if no cog available
''
'' mode bit 0 = invert rx
'' mode bit 1 = invert tx
'' mode bit 2 = open-drain/source tx
'' mode bit 3 = ignore tx echo on rx

'  stop
PUB readNEMA
  Null[0] := 0
  repeat
   longfill(gps_buff,20,0)      
   repeat while Rx <>= "$"      ' wait for the $ to insure we are starting with
     Rx := uart.rx              '   a complete NMEA sentence 
   cptr := 0

   repeat while Rx <>= CR       '  continue to collect data until the end of the NMEA sentence 
     Rx := uart.rx              '  get character from Rx Buffer
     if Rx == ","
       gps_buff[cptr++] := 0    '  If "," replace the character with 0
     else
       gps_buff[cptr++] := Rx   '  else save the character   
    
   if gps_buff[2] == "M"         
     if gps_buff[3] == "W"        'When just logging MWV:ok, including VWR => errors!    
       if gps_buff[4] == "V"              'stack=1000 no improvement
         if gps_buff[10] == "T"           
           copy_buffer(@MWVb, @MWVa)      'No MWV: ok!!
       
   if gps_buff[2] == "V"               'AWA, AWS
     if gps_buff[3] == "W"            
       if gps_buff[4] == "R"
         copy_buffer(@VWRb, @VWRa)
         
   if gps_buff[2] == "R"                '$IIRMC,110857,A,5217.977,N,00515.917,E,00.0,284,150112,00,E,A*08
     if gps_buff[3] == "M"              '           0   1    2     3     4     5  6    7     8    9 10 11
       if gps_buff[4] == "C"
         copy_buffer(@RMCb, @RMCa)       
      
pub copy_buffer ( buffer,args)
         bytemove(buffer,@gps_buff,cptr) '  copy received data to buffer
         ptr := buffer
         arg := 0
         repeat j from 0 to 78           ' build array of pointers
          if byte[ptr] == 0               ' to each
             if byte[ptr+1] == 0           ' record
                long[args][arg] := Null     ' in 
             else                            ' the
                long[args][arg] := ptr+1     ' data buffer
             arg++
          ptr++
          
' now we just need to return the pointer to the desired record

'$IIMWV,079,T,04.2,N,A*1D
'         0 1  2   3  4 
pub MWV0TWA
   return MWVa[0]                     'winddirection

pub MWV1TR
   return MWVa[1]                     'True or Relative

pub MWV2TWS
   return MWVa[2]                     'windspeed   

pub MWV3
   return MWVa[3]                     'when shifted, this will log MWV2   

pub MWV4
   return MWVa[4]                     'when shifted, this will log MWV3   

'$IIVWR,088,R,02.5,N,,,,*66
'        0 1  2   3     4
pub VWR0AWA
   return VWRa[0]

pub VWR1LR
   return VWRa[1]

pub VWR2AWS
   return VWRa[2]

pub VWR3
   return VWRa[3]

pub VWR4
   return VWRa[4]
   
pub VWR5
   return VWRa[5]
      
'$IIRMC,110857,A,5217.977,N,00515.917,E,00.0,284,150112,00,E,A*08
'          0   1    2     3     4     5   6    7     8   9 10 11
'        time vald  Lat   North Lon  East BS     date  var E Chcksum
pub RMC0time
   return RMCa[0]

pub RMC1valid
   return RMCa[1]
      
pub RMC2lat
   return RMCa[2]
    
pub RMC3NS
   return RMCa[3]
     
pub RMC4lon
   return RMCa[4]
    
pub RMC5EW
   return RMCa[5]
      
pub RMC6bs
   return RMCa[6]

pub RMC7heading
   return RMCa[7]
   
pub RMC8date
   return RMCa[8]    

pub RMC9var
   return RMCa[9]    

pub RMC10E
   return RMCa[10]    

pub RMC11Checksum
   return RMCa[11]    